#!/bin/sh

echo "Maja, (c) 2000,2001,2002,2003 by Jean-Dominique Frattini."
echo "Configure and makefile autogeneration."
echo ""

autogen () {
	echo "Autogeneration, this may take a while..."
	aclocal
	automake
	autoconf
}

if [ $# = 0 ] ; then
	autogen
	echo "Next, you should execute ./configure"
	echo -n ""
	exit 0
elif [ $1 = "--with-make" ] ; then
	autogen
	./configure
	make
elif [ $1 = "--with-install" ] ; then
	autogen
	./configure
	make
	make install
elif [ $1 = "--with-ask" ] ; then
	autogen
	echo "Do you want me to run configure now ? (y/n)"
	read answer
	if [ $answer = "n" ] ; then
		exit 0
	fi
	echo "Enter options to configure (just type Enter if none): "
	read options
	./configure $options
	echo "Do you want me to compile now ? (y/n)"
	read answer
	if [ $answer ="n" ] ; then
		exit 0
	fi
	make
	echo "Do you want me to install the libraries ? (y/n)"
	if [ $answer ="n" ] ; then
		exit 0
	fi
	make install
elif [ $1 = "--help" ] ; then
	echo "autogen.sh: Maja autogeneration for compilation"
	echo "generate configure and Makefiles for the compilation"
	echo "Usage: ./autogen [ option ]"
	echo "with option could be: "
	echo "	--with-make: generate then run configure and make"
	echo "	--with-install: same as --with-make, but add make install"
	echo "	--with-ask: ask before each step"
	echo "when no option, only generate configure and Makefiles"
fi
