/*!file
	very simple demo example of how to use Maja with its interface.
	This is earlier version, so things may change in the future.
	This file is free software, do what you want with it, but there is
	absolutely no warranty on its use, modification, or any purpose.
	2000,2001,2002,2003 by Jean-Dominique Frattini (jdf).
*/

#include <maja/maja.h>

using namespace maja;

int main( int argc, char **argv)
{
	MAJAMATHS::MajaVector cam_size( 1,2,1);
	MAJAMATHS::MajaVector cam_acc( 20,20,20);
	
	MajaSystemInterface<MajaDefaultGameEngine> *my_system= new MajaSystemInterface<MajaDefaultGameEngine>( argc, argv);
	if( !my_system)
		return 1;
	
	MajaDefaultGameEngine& game_engine= my_system->GetGameEngine();
	
	MajaObject *def_obj= new MajaScene;
	std::string mfile= "models/scene1.3ds";
	def_obj->SetModelFile( mfile);

	MajaObject *def_obj2= new MajaScene;
	mfile= "models/scene2.3ds";
	def_obj2->SetModelFile( mfile);

	MajaObject *def_obj3= new MajaScene;
	mfile= "models/scene3.3ds";
	def_obj3->SetModelFile( mfile);

	MajaObject *def_obj4= new MajaScene;
	mfile= "models/scene4.3ds";
	def_obj4->SetModelFile( mfile);

	MajaObject *def_dome= new MajaScene;
	mfile= "models/dome.3ds";
	def_dome->SetModelFile( mfile);
	
	MajaObject *def_path= new MajaPath;
	mfile= "models/ground.3ds";
	def_path->SetModelFile( mfile);
	
	MajaCamera *def_cam= new MajaCamera;
	def_cam->SetLiveTarget( def_obj->GetPos());
	def_cam->SetMode( camera_mode_follow|camera_mode_revolution);
	def_cam->SetPos( 0,20,0);
	def_cam->SetSize( cam_size);
	def_cam->SetAcceleration( cam_acc);
	
	game_engine.AddLoadElement( *def_obj,  object_type_obstacle);
	game_engine.AddLoadElement( *def_obj2, object_type_obstacle);
//	game_engine.AddLoadElement( *def_obj3, object_type_obstacle);
//	game_engine.AddLoadElement( *def_obj4, object_type_obstacle);
	game_engine.AddLoadElement( *def_path, object_type_terrain);
//	game_engine.AddLoadElement( *def_dome, object_type_object);
	game_engine.AddCamera(      *def_cam,  object_type_camera|object_type_player);
	
	my_system->Start();

	return 0;
}
