/*
	majatxtmgr.h
	ce fichier est une partie de Maja - this is a part of Maja
	simples politiques de sorties textes
	simple text outputs policies
	
	$Id: $

	$Log: $

	begin:			Wed Dec 12 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJATXTMGR__H
#define MAJATXTMGR__H

#include <iostream>
#include <string>
#include "majatypes.h"
#include "majatemp.h"
#include "majatxt.h"

namespace maja
{
	//
	// text manager:
	// there may be interresting things it could do
	//

	template 
	<
		class STRING,
		template <class> class OUT,
		template <class> class ThreadingModel
	>
	class MajaTextManager_: public OUT<STRING>//,
				//public ThreadingModel
	{
		std::string	current_text;
		mint 		px, py;

		public:

		MajaTextManager_( mvoid):	OUT<STRING>()
		{
			px=0;
			py=0;
		}
	};

//	typedef MajaTextManager_<std::string, MajaStdOut, MajaNoChecking> MajaOutString;
	
	// will disappear soon
	template 
	<
		class OutWayText,
		template <class> class InputText//,
//		template <class> class ThreadingModel= MajaNoChecking<mint>
	>
	class MajaTextManager: 	public OutWayText,
				public InputText<std::string>
	{
		std::string	current_text;
		mint 		px, py;

		public:

		MajaTextManager( mvoid):	OutWayText()
		{
			px=0;
			py=0;
		}

		mvoid GetTextFromInput( std::string& input){
		/*	char *tmp= (char*)input.c_str();
			char to_s[128]=" ";
			int beg= 0;
			int fol= 0;
		
			_y-=_h;
		
			while( tmp[fol]!='\0'){
				while( tmp[fol]!='\n'){
					to_s[fol-beg]=tmp[fol];
					fol++;
				}
				current_text= to_s;
				Locate( _x, _y+=_h);
				Print( current_text);
				beg=++fol;
			}*/
		}
	};

	//
	// simple typedefs
	// users, if not using their own manner, should use what Maja
	// provides, and use these ones.
	// 

	// use cout
	typedef MajaTextManager<MajaStdOut<std::string>, MajaNoChecking> MajaOutString;
	typedef MajaTextManager<MajaStdOut<std::string>, MajaNoChecking> MajaOutString;

	// use cerr
	typedef MajaTextManager<MajaStdErr<std::string>, MajaNoChecking> MajaErrString;

	// glx outputs, default is X fixed font
	#ifndef WIN32
	typedef MajaGlxOut<std::string> MajaGlxOutString;
	typedef MajaTextManager<MajaGlxOutString, MajaNoChecking> MajaGlString;
	#endif
}// namespace maja
#endif
 
