/*
	majacoremutex.h
	ce fichier est une partie de Maja - this is a part of Maja
	structure contenant tous les mutexes
	structure containing all mutexes
	
	$Id: $

	$Log: $

	begin:			Fri Jul 5 2002
	copyright:		(C) 2000, 2001, 2002 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	Contactez-nous pour toute tentative d'utilisation commerciale, svp.			*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *	Contact us for any commercial use attempt, please.					*
 *												*
 ************************************************************************************************/

#include "../layers/th/mutex.h"

#ifndef MAJA_CORE_MUTEX__H
#define MAJA_CORE_MUTEX__H

namespace maja
{
	namespace MAJACORE
	{
		/*!
		 * all mutexes that are related to the core.
		 * each module uses at least one of them.
		 * any mutex that match these rules must be
		 * declared and used by here.
		 * TODO: maybe, surely, each module would have its proper mutex, and
		 * make a policy to allow threadsafe classes as window...
		 *
		 * status: useable
		 *
		 * info: this is intended to disappear when outputs utilities ready
		 */
		static struct MajaCoreMutex
		{
			//! mutex for the stdout mutex
			//! note that Maja uses a lot of stderr outputs, so this
			//! synchronizes all of these
			MAJATHREAD::MajaMutex stderr_mutex;

			//! mutex for the stdout
			//! this could be used for normal console outputs.
			MAJATHREAD::MajaMutex stdout_mutex;

			//! we construct here the window mutex which is special, with having
			//! some conditions related to itself
			MajaCoreMutex( void){
			}

			~MajaCoreMutex( void){
			}
		}maja_core_mutex;
	}
}
#endif
