/*
	majaevent.h
	ce fichier est une partie de Maja - this is a part of Maja
	les vnements relatifs  l'ordonnancement
	events relative to the scheduler

	$Id: $

	$Log: $

	begin:		Thu Sep 05 2002
	copyright:	(C) 2002 by Jean-Dominique Frattini
	email:		jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	Contactez-nous pour toute tentative d'utilisation commerciale, svp.			*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *	Contact us for any commercial use attempt, please.					*
 *												*
 ************************************************************************************************/

#ifndef __MAJA_EVENT_H
#define __MAJA_EVENT_H

/*!file
	NOTES:
	* DON'T ATTEMPT TO USE THIS CAPABILITIES AS FAR AS THEY
	ARE NOT COMPATIBLE WITH THE ACTUAL MODULES !!
	THIS IS SIMPLY PURE THEORICALLY, AND WAS NOT TESTED
	ON ANY WAY BUT JUST COMPILED WITH NO ERROR.
	
	* THIS WILL DETERMINATE THE FIRST MINOR VERSION OF MAJA (0.1)
	WHEN IT WILL BE FULL IMPLEMENTED AND TESTED. SO, DON'T USE
	IT UNTIL THE MAJA VERSIONS ARE 0.1 AND OVER.
	
	* THIS SERVES ME TO TEST MY MODELISATION WITH UML, AND IS ONLY
	USEFULL FOR ME AND ANY EVENTUAL CONTRIBUTORS WHO WILL INVOLVE
	THEMSELF IN THE CORE.
*/

/*!
	All event types know by Maja are here
	if not listed, never add any event after busy
	that is used as the last (so maximum) value.
*/
enum MajaEventType
{
	//! no event, use it if you don't want to communicate with the core and its modules
	MET_event_none=		0,
	
	//! event saying that all was started succesfully
	MET_event_on=			1,
	
	//! on air, but is disturbable
	MET_event_running=		2,
	
	//! event to return if a component is starting but not operational yet
	MET_event_starting=		4,
	
	//! pause attempt
	MET_event_pause=		8,
	
	//! when a component is in termination, but not til ended
	MET_event_stopping=	16,
	
	//! when a component is busy and could not be disturbed.
	//! THIS MUST STAY THE LAST VALUE !
	MET_event_busy=		32
};		
	
/*!
	a class that stands all events above
*/
class MajaEvent
{
	protected:
	
	//! the event
	MajaEventType event;

	public:
	
	// that's needed for full compatibility with the containers, so a bit ashamed...
	char* GetName( void){ return 0x0;}

	// idem
	void SetName( char* n){ ;}

	MajaEvent( void){
		event= MET_event_none;
	}
	
	MajaEvent( MajaEventType ev){
		event= ev;
	}
	
	~MajaEvent( void){
		;
	}
	
	//! set the event to be sended
	inline int SetEvent( MajaEventType& ev){
		if( ev> MET_event_busy)
			return -1;
		return event= ev;
	}

	//! get the event saved by SetEvent
	inline MajaEventType& GetEvent( void){
		return event;
	}
};
#endif
