/*
	majaservice.h
	ce fichier est une partie de Maja - this is a part of Maja
	un service est un module
	a service is a module

	$Id: $

	$Log: $

	begin:		Thu Sep 05 2002
	copyright:	(C) 2002 by Jean-Dominique Frattini
	email:		jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	Contactez-nous pour toute tentative d'utilisation commerciale, svp.			*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *	Contact us for any commercial use attempt, please.					*
 *												*
 ************************************************************************************************/

#ifndef __MAJA_SERVICE_H
#define __MAJA_SERVICE_H

#include "majaevent.h"

/*!file
	NOTES:
	* DON'T ATTEMPT TO USE THIS CAPABILITIES AS FAR AS THEY
	ARE NOT COMPATIBLE WITH THE ACTUAL MODULES !!
	THIS IS SIMPLY PURE THEORICALLY, AND WAS NOT TESTED
	ON ANY WAY BUT JUST COMPILED WITH NO ERROR.
	
	* THIS WILL DETERMINATE THE FIRST MINOR VERSION OF MAJA (0.1)
	WHEN IT WILL BE FULL IMPLEMENTED AND TESTED. SO, DON'T USE
	IT UNTIL THE MAJA VERSIONS ARE 0.1 AND OVER.
	
	* THIS SERVES ME TO TEST MY MODELISATION WITH UML, AND IS ONLY
	USEFULL FOR ME AND ANY EVENTUAL CONTRIBUTORS WHO WILL INVOLVE
	THEMSELF IN THE CORE.
*/

/*!
	A service could accept any module to be used in the scheduler core system
	A MODULE HAS TO BE INHERITED FROM MajaSModule (cf majasmodule.h)
*/
template <class _MajaModule> class MajaService
{
	protected:
	
	char				*name;
	
	//! any module must use event (mmm maybe better in modules themselves ???
	//! this will permit to send more easily any events that have to occur
//	MajaEvent		event;
	
	//! the module itself: he must be derived from MajaSModule (cf scheduler/majasmodule.h)
	//! but as far as now the only implementation of the modules uses thread, and as it wiil be
	//! the core to give the thread onto which the module will run, it's quite bad done...
	_MajaModule	*module;
	
	//! any library dependencies should be set here
	char				**layer_deps;
	
	//! how many of lib dep are there ?
	int				deps_nb;
	
	public:
	
	MajaService( void){
		layer_deps= NULL;
		deps_nb= 0;
		name= NULL;
		module= NULL;
	}
	
	MajaService( _MajaModule *mod){
		layer_deps= NULL;
		deps_nb= 0;
		name= NULL;
		module= mod;
	}
	
	inline char* GetName( void){ return module->GetName();}
	
	inline void SetName( char* n){ module->SetName( n);}
	
	//! this just link the pointers, and not allocate, so the
	//! deps argument must stay alive all the running time.
	inline void SetDependencies( char **deps, int nb){
		deps_nb= nb;
		layer_deps= deps;
	}
	
	inline char** GetDependencies( void){ return layer_deps;}
	
	inline int StartModule( void){ return module->EnterDefaultMode();}
	
	//inline int StopModule( void){ return module.LeaveDefaultMode();}
	
	inline _MajaModule*	GetModule( void){ return module;}
	
	inline void SetModule( _MajaModule *mod){ module= mod;}
};
#endif
