/*
	majastates.h
	ce fichier est une partie de Maja - this is a part of Maja
	la plupart des tats
	almost states
	
	$Id: $

	$Log: $

	begin:			Fri Jul 5 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef __MAJASTATES_H
#define __MAJASTATES_H

namespace maja
{
	/*!
	 * general way of scheduling, only for scheduler
	 * (any states in a state.h file)
	 */
	enum __MajaGeneralState
	{
		//! state not started
		MGS_state_off,
		
		//! state starting
		MGS_state_start,
		
		//! state pause
		MGS_state_pause,
		
		//! state started & running
		MGS_state_normal
	};
	
	/*!
	 * stand way of the scheduler
	 */
	enum __MajaSchedulingState
	{
		//! the scheduler is the main thread, in the main processus
		MSS_state_parent,
		
		//! the scheduler is inherited form another thread or processus
		MSS_state_inherited
	};

	/*!
	 * state of a maja scheduler module
	 * there is no value set to 1 as some (member) functions could
	 * return this state
	 */
	enum __MajaModuleState
	{
		//! module not created
		MMS_state_off= 0,

		//! module is started but waiting to run
		MMS_state_start,
		
		//! module started and running
		MMS_state_on,
		
		//! module is busy, could not be disturbed
		MMS_state_busy,
		
		//! module paused
		MMS_state_pause,
		
		//! ask to cancel module thread(s)
		MMS_state_cancel
	};

	/*
	 * different states of the window
	 */
	enum __MajaWindowState{
		//! window is dead or not created yet
		MWS_state_dead= 0,

		//! window is alive
		MWS_state_alive,

		//! window needs to be redrawn
		MWS_state_need_redraw,

		//! window needs to be resized
		MWS_state_need_resize,

		//! windows needs to be closed
		MWS_state_need_close,

		//! window need fullscreen/window switch
		MWS_state_need_switch
	};
}
#endif

