/*
	majagamemenu.h
	ce fichier est une partie de Maja - this is a part of Maja
	menu du moteur de jeux
	menu of the game engine

	$Id: $

	$Log: $

	begin:			nov 2003
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJA_GAMEMENU__H
#define MAJA_GAMEMENU__H

#include "majagamemain.h"
#include "../../tools/maths/majavector.h"
#include "../interactivity/keymatch.h"

#include "../../common/majacom.h"

namespace maja
{
namespace MAJAGAME
{
	/*!
	 * game menu moment
	 * need one more template: I which is the Interactivity engine
	 * so MajaInteractivityEngine (MajaIEngine) should have some
	 * things to respect
	 * M is a menu (cf engines/menu)
	 */
	template
	<
		class O, 
		class I,
		class M		
	>
	class MajaGameMenu: virtual public MajaGameMain<O>
	{
		protected:

		MAJACONTAINER::MajaList<O>	menu_list;
		
		I				*i_engine;

		M				*m_engine;
		
		public:

		MajaGameMenu( mvoid):	MajaGameMain<O>()
		{
			i_engine= mnull;
			m_engine= mnull;
		}

		mcom Run( mvoid){			
			static MAJAMATHS::MajaVector& mp= *(i_engine->GetMouse());
			static MAJA_KEY *kp= i_engine->GetCurrentKeyMouse();
			
			return m_engine->Test( (mint)mp.x, (mint)mp.y, (*kp)==MAJA_MOUSE_1?1:0);
		}

		mcom Unrun( mvoid){
			return 1;
		}

		mvoid AddMenuElement( O& element){
			menu_list.Add( e);
		}
	};

	template
	<
		class O,
		class I,
		class M,		
		class OUTPUT
	>
	class MajaGameMenuCom_:	public	MajaCom<MajaGameMenu<O,I,M>, OUTPUT>
	{
		MajaGameMenuCom_():	MajaCom<MajaGameMenu<O,I,M>,OUTPUT>()
		{
			;
		}

		mcom Run( mvoid){
			mcom ans= mcom_nothing;
			
			ans= input.Run();

			output << ans;
			
			if( ans< mcom_error)
				return mcom_no_change;
		}

		mcom Unrun( mvoid){

			return 1;
		}
	};
}
}
#endif
