/*
	graphictree.h
	ce fichier est une partie de Maja - this is a part of Maja
	un arbre pour grer tout le graphism
	a tree for managing the whole graphism

	$Id: $

	$Log: $

	begin:			Wed Jun 19 2002
	copyright:		(C) 2002 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	Contactez-nous pour toute tentative d'utilisation commerciale, svp.			*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *	Contact us for any commercial use attempt, please.					*
 *												*
 ************************************************************************************************/

#ifndef __GRAPHIC_TREE_H
#define __GRAPHIC_TREE_H

#include "graphext.h"
#include "gbase.h"
#include "majagdata.h"
#include "majagmaterial.h"
#include "majagmesh.h"
#include "majagtext.h"
#include "gdatatree.h"
#include "majagparam.h"

namespace maja
{
namespace MAJAGRAPHIC{
	
/*!
	The root branch of the graphic tree
	generally, you only have one root on one tree.
	
	status: in development
*/
class MajaGRoot: public MajaGEntity
{
	public:
	//! any graphic_branch linked to this root tree
	MajaGParam *graphic_branch;
	
	//! the number of branches linked to this tree
	GLuint branch_nb;

	MajaGRoot( void): MajaGEntity(){
		graphic_branch= NULL;
		branch_nb= 0;
	}

	//! set the branches that are attached to the root
	inline void SetBranch( MajaGParam *branch, GLuint nb)
	{
		graphic_branch= branch;
		branch_nb= nb;
	}

	//! render the whole root
	inline GLuint Render( void)
	{
		for( GLuint i=0; i<branch_nb; i++)
			graphic_branch[ i ].Render();
		
		return 1;
	}
	
	//! check if all is well before try to render
	bool Check( void);
};
}
}
#endif
