/* $Id: $
 * param material for a graphic
 * Copyright (C) september 2000,2001,2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf imagergb.cpp et imagergb.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: $
 */

#ifndef __MAJAGMATERIAL_H
#define __MAJAGMATERIAL_H

#include "gbase.h"

/*!
	this would be a list of material
*/
class MajaGMaterial
{
	public:
	GLfloat	*materials;
	GLuint	nb;
	
	MajaGMaterial( void){
		materials= NULL;
		nb= 0;
	}
	~MajaGMaterial( void){
		free( materials);
	}
	
	GLuint SetNewMaterial( GLfloat *mat){
		GLfloat *temp= (GLfloat*)realloc( materials, (10*(nb+1))*sizeof( GLfloat));
		if( !temp) return false;
		materials= temp;

		for( GLuint i= 10*nb; i<10*(nb+1); i++){
			if( mat)
				materials[i]= mat[i-10*nb];
			else
				materials[i]= 0;
		}
		nb++;
		return nb;
	}
	
	bool RemoveMaterial( GLuint n){
		if( n>nb || n<0) return false;
		if( n<nb)
			for( GLuint i=n; i<nb-1; i++)
				materials[10*i]= materials[10*(i+1)];
		GLfloat *temp= (GLfloat*)realloc( materials, (10*(nb-1))*sizeof( GLfloat));
		if( !temp) return false;
		return true;
	}
};

class MajaGMaterialTree
{
	public:
	GLfloat *mat;
};
#endif
