/* $Id: $
 * a graphic complete meshes of a loaded object
 * Copyright (C) 2000, 2001, 2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: $
 */

#ifndef __MAJA_G_MESH
#define __MAJA_G_MESH

#include "../../tools/maths/majamaths.h"
#include "majagmaterial.h"
#include "majagtext.h"
#include "majagdata.h"
#include <stdlib.h>
#include <string.h>

namespace maja
{
using namespace MAJAMATHS;

namespace MAJAGRAPHIC{

/*!
	A graphic mesh
*/
class MajaGMesh
{
	protected:
		
	mchar		*name;
	
	public:
	
	MajaGMaterial mat;
	
	MajaGTexture tex;
	
	MajaGData *data;
	
	GLuint data_nb;
	
	MAJAMATHS::MajaVector *pos;
	
	MAJAMATHS::MajaVector *rot;
	
	MajaGMesh( mvoid){
		data= NULL;
		data_nb=0;
		name= NULL;
	}
	
	MajaGMesh( mint i){
		data= NULL;
		data_nb=0;
		name= NULL;
	}
	
	MajaGMesh( MajaGMesh& m){
		mat= m.mat;
		tex= m.tex;
		data= m.data;
		data_nb= m.data_nb;
	}
	
	~MajaGMesh( mvoid){
		// keep it comment until it's allocated here (better solution ?)
		// or maybe because it's an array
		;//delete data;
	}
	
	mchar* GetName( mvoid){ return name;}
	
	mvoid SetName( mchar *n){ 
		name= new mchar[strlen( n)+1]; 
		strcpy( name, n);
	}
};
}
}
#endif
