/* $Id: $
 * textures container
 * Copyright (C) september 2000,2001,2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: $
 */

#ifndef __MAJA_TEXTURES_H
#define __MAJA_TEXTURES_H

#include "majatex.h"
#include "../../tools/containers/majalist.h"

namespace maja
{

/*!
	A container of textures
	manage the loading and the id
	avoid the redundance of same textures
*/
class MajaTextures
{
	private:

	static bool first;
	
	protected:
	
	//! all the list of textures
	static MAJACONTAINER::MajaList<MajaTex> textures;
	
	//! a general directory (not used for now)
	char *directory;

	static GLuint	maja_tex_id;
	
	public:
	
	MajaTextures( void);
	
	MajaTextures( const MajaTextures& tex){
		directory= new char[strlen( tex.directory)+1];
		strcpy( directory, tex.directory);
		first= tex.first;
	}
	
	~MajaTextures( void){
		if( directory)
			delete[] directory;
	}
	
	//! Load all the textures in memory, not implemented
	bool LoadAll( void);
	
	inline bool Load( void){ 
		return LoadAll();
	}
	
	//! Create a new texture, but doesn't load
	GLuint Create( char *texture_file_name, char *directory_name= NULL);
	
	//! set the directory of the whole textures
	void SetDirectory( char* dir);

	GLuint GetLogoId( void){
		return maja_tex_id;
	}
};
}
#endif
