/*
	majacontroler.h
	ce fichier est une partie de Maja - this is a part of Maja
	controleur d'interaction par dfaut et clavier
	default interactivity controler and keyboard

	$Id: $

	$Log: $

	begin:			Mon Jul 15 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJA_CONTROLER_H
#define MAJA_CONTROLER_H

#include <stdlib.h>
#include <iostream>
#include "../../core/majastates.h"
#ifndef WIN32
#include <GL/glx.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
#endif
#include "keymatch.h"
#include "../../tools/maths/majavector.h"

namespace maja
{
	class MajaControler
	{
		protected:
	
		__MajaWindowState 	state;
	
		mutable mint		end_key;

		mchar			current_c;
	
		MAJA_KEY		current_k;

		MAJA_KEY		current_k_mouse;

		MAJAMATHS::MajaVector	pos;
	
		MajaControler( void){
			end_key= MAJA_KEY_ESCAPE;
			current_c= '\0';
			current_k= 0;
		}

		MajaControler( const MajaControler& key){
			state= key.state;
			end_key= key.end_key;
			current_c=key.current_c;
			current_k=key.current_k;
		}
	
		public:
	
		virtual ~MajaControler( void){
			;
		}
	
		virtual __MajaWindowState CheckEvent( XEvent& e)=0;

		char GetCurrentChar( void){ return current_c;}

		MAJA_KEY* GetCurrentKey( void){ return &current_k;}

		MAJA_KEY* GetCurrentKeyMouse( void){ return &current_k_mouse;}

		MAJAMATHS::MajaVector* GetPos( void){ return &pos;}
	};
}
#endif
