/*
	majaiengine.h
	ce fichier est une partie de Maja - this is a part of Maja
	moteur d'interaction
	interactivity engine

	$Id: $

	$Log: $

	begin:			Mon Jul 15 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJA_IENGINE_H
#define MAJA_IENGINE_H

#include "keymatch.h"
#include "majakeyboard.h"
#include "majamouse.h"
#include <string>
#include <list>

// birk !!! maybe clock into common, seems best since it's often used
#include "../../core/majaclock.h"
#include "../../layers/th/mutex.h"

namespace maja
{
//! this is the constant that uses some classes above to refer from
//! a time-diff between 2 user key inputs.
//! let it to 0 tells you don't want any time limitation
#define MAJA_MAX_INT_DT			0.5

//typedef __MajaMouseButton MajaIState;

class MajaIMatch
{
	std::list<mint>	key_list;

	public:

	MajaIMatch( mvoid){
		;
	}

	~MajaIMatch( mvoid){
		;
	}

	mbool AddMatch( mint key){
		key_list.push_front( key);
		std::cerr << std::endl << "adding key...";

		return mtrue;
	}

	mint GetMatch( mint n){
		mint j;
		std::list<mint>::iterator i= key_list.begin();
		
		for( j=0; i!=key_list.end(); i++,j++)
			if( *i==n)
				return j;
		return 0;
	}		
};

class MajaIEngine:	public MajaControler,
			public MAJATHREAD::MajaMutex
{
	MajaControler		*keyer;

	MajaControler 		*mouser;

	MajaIMatch		interer;

//	MajaIStringEngine	string_engine;
	
	public:

	MajaIEngine( mvoid):	MajaControler(),
				MAJATHREAD::MajaMutex()
	{
		keyer= new MajaKeyboard;
		mouser= new MajaMouse;
		
		if( !keyer || !mouser)
			std::cerr << "MajaIEngine: memory full";
		
		//mouser->SetDisplay( window->GetDisplay());
		//mouser->SetWindow( &window->GetWindow());
		//mouser->Create();
		//mouser->SetInputFocus();
		//mouser->Grab();
	}

	~MajaIEngine( mvoid){
		delete keyer;
		delete mouser;
	}

	__MajaWindowState CheckEvent( XEvent& e){
		__MajaWindowState 	s;
		
		mouser->CheckEvent( e);
		s= keyer->CheckEvent( e);
	//	string_engine.Add( keyer->GetCurrentChar());
		current_k= *keyer->GetCurrentKey();
		current_k_mouse= *mouser->GetCurrentKeyMouse();

		return s;
	}
	
	inline mvoid ResetCurrentKey( mvoid){ 
		current_k= mnull;
	}

	inline MAJAMATHS::MajaVector* GetMouse( mvoid){
		return mouser->GetPos();
	}
};
}
#endif
