/*
	majaiengine.h
	ce fichier est une partie de Maja - this is a part of Maja
	moteur d'interaction
	interactivity engine

	$Id: $

	$Log: $

	begin:			Mon Jul 15 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJA_ISTRING_H
#define MAJA_ISTRING_H

#include "keymatch.h"
#include <string>
#include <list>

// birk !!! maybe clock into common, seems best since it's often used
#include "../../core/majaclock.h"
#include "../../layers/th/mutex.h"

namespace maja
{
//! this is the constant that uses some classes above to refer from
//! a time-diff between 2 user key inputs.
//! let it to 0 tells you don't want any time limitation
#define MAJA_MAX_INT_DT			0.5

class MajaIStringBase
{
	protected:
	
	std::string	_s;

	MajaClock	_c;

	bool		_start;

	float		_dt;

	//! last time added
	float		_lt;

	public:

	MajaIStringBase(){
		_s= "";
		_start= false;
		_dt= MAJA_MAX_INT_DT;
		_lt= 0;
	}

	virtual ~MajaIStringBase(){}

	virtual void Add( char c){
		std::cerr << std::endl << "MajaIStringBase: adding new character.";
		char *c2= new char( c);
		float t=0;
		
		if( !_start){
			_start=!_start;
			_c.Start();
			_lt= _c.Clock();
			return;
		}
		else{
			if( _dt && ( (t=( _c.Clock()-_lt))<_dt)){
				_s.append( c2);
				_lt= t;
			}
			else
				_s= c;
		}
	}
};

class MajaIStringWaiter: virtual public MajaIStringBase
{
	public:

	MajaIStringWaiter( void): MajaIStringBase(){
		;
	}
};

class MajaIStringViewer: virtual public MajaIStringBase
{
	public:

	MajaIStringViewer( void): MajaIStringBase(){
		;
	}
};

class MajaIStringMaker: virtual public MajaIStringBase
{
	public:

	MajaIStringMaker( void): MajaIStringBase(){
		;
	}
};

class MajaIStringEngine:public MajaIStringWaiter, 
			public MajaIStringViewer,
			public MajaIStringMaker
{
	protected:
	
	MajaIStringWaiter::_s;
	
	MajaIStringViewer::_s;

	MajaIStringMaker::_s;

	public:

	MajaIStringEngine( void){
		;
	}
};

}

#endif

