/*
	majakeyboard.h
	ce fichier est une partie de Maja - this is a part of Maja
	support du clavier
	keyboard support

	$Id: $

	$Log: $

	begin:			Mon Jul 15 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJA_KEYBOARD_H
#define MAJA_KEYBOARD_H

#include <stdlib.h>
#include <iostream>
#include "../../core/majastates.h"
#ifndef WIN32
#include <GL/glx.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
#endif
#include "keymatch.h"
#include "majacontroler.h"

namespace maja
{
#ifdef SHOW_SINTER_INFO
#undef SHOW_SINTER_INFO
#endif

/*
	il faudra que l'on puisse paramtrer les touches
	mais: diffrent si pendant jeu ou pendant un menu...
	il faudra srement faire une liste d'tat nomme que l'on utilisera
	en fonction du moment.

	ne s'occupe plus que du clavier, la souris tant laisse  MajaCursor
*/
class MajaKeyboard: public MajaControler
{
	// key
	KeySym	key;

	public:
	
	MajaKeyboard( mvoid): MajaControler()
	{
		;
	}

	MajaKeyboard( const MajaKeyboard& k): MajaControler( (const MajaKeyboard&)k){
		key= k.key;
	}
	
	~MajaKeyboard( mvoid)
	{
		;
	}
	
	//! Check an event
	//! this is very bad done !!!
	__MajaWindowState CheckEvent( XEvent& e){
		static mbool on_alt= mfalse, done= mfalse;

		switch( e.type){
			case KeyPress:
				key= XLookupKeysym( &e.xkey, 0);
				if( key== (muint)end_key)
					done= mtrue;
				else if( key== XK_Alt_L || key== XK_Alt_R)
					on_alt= mtrue;
				else if( key== XK_Return)
					if( on_alt){
						on_alt=!on_alt;
						return state= MWS_state_need_switch;
					}
				current_k= key;
				current_c= key+MAJA_KEY_DIFF_ASCII;
				break;
			case KeyRelease:
				;
			default:
				current_k= MAJA_KEY_NULL;
				break;
		}

		if( done)
			return state= MWS_state_need_close;
		
		return state= MWS_state_alive;
	}
};
}
#endif

