/*
	majamouse.h
	ce fichier est une partie de Maja - this is a part of Maja
	support de la souris
	mouse support

	$Id: $

	$Log: $

	begin:			Mon Jul 15 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJA_MOUSE__H
#define MAJA_MOUSE__H

#ifndef WIN32
#include <GL/glx.h>

#include "../../layers/wm/majamainwindow.h"
#include "../../tools/maths/majavector.h"
#include "majacontroler.h"

namespace maja
{

	enum __MajaMouseButton
	{
		MMB_button_up		= 0,
		MMB_button_down		= 1,
		MMB_button_released	= 2,
		MMB_button_clicked	= 3	// has to be equal to down+released
	};

	class MajaMouse: public MajaControler
	{
		Display		*display;
	
		_MajaWindow	*window;

		//MajaDrawable	*drawable; // will replace display and window (+ glx 1.3 comp)
	
		Cursor		cursor;
	
		public:

		MajaMouse( mvoid): MajaControler()
		{
			display= mnull;
			window= mnull;
		}

		mvoid Create( mvoid);

		mvoid Grab( mvoid);

		mvoid SetInputFocus( mvoid);

		mvoid SetDisplay( Display *d){
			display=d;
		}

		mvoid SetWindow( _MajaWindow *w){
			window=w;
		}

		__MajaWindowState CheckEvent( _MajaWinEvent& e);
	};

}

#else
;
#endif

#endif

