/*
	majalabel.h
	ce fichier est une partie de Maja - this is a part of Maja
	simple label de menu
	simple menu label

	$Id: $

	$Log: $

	begin:			Fri Jul 5 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef __MAJA_LABEL_H
#define __MAJA_LABEL_H

#include "../scenery/majaobject.h"
#include "../../common/majatxtmgr.h"

namespace maja
{

class MajaLabel: public MajaObject
{
	protected:
		
	GLuint				image_id;
	
	std::string			font;
	
	MAJAMATHS::MajaQuaternion	color;
	MAJAMATHS::MajaQuaternion	text_color;

	std::string 			label;

	//! what permit to see the text on screen.
	//! is static because to avoid display
	//! connection for each label which would
	//! be shameful.
	static MajaGlString		text_out;
	
	public:
	
	MajaLabel( mvoid): MajaObject(){
		Init();
	}

	~MajaLabel( mvoid){
		;
	}

	protected:
	
	mvoid Init( mvoid){
		color.x=1;
		color.y=1;
		color.z=1;
		color.w=.5;
		text_color.w=1;
		font= "fixed";
		label= "";
		image_id= 0;
	}

	public:
	
	inline mvoid SetImage( GLuint im_id){ image_id= im_id;}
	inline GLuint GetImage( mvoid){ return image_id;}
	
	inline mvoid SetLabel( std::string l){
		label= l;
	}	
	inline std::string& GetLabel( mvoid){ 
		return label;
	}
	
	inline mvoid SetFont( std::string f, muint s= 0){ font= f;}
	inline std::string& GetFont( mvoid){ return font;}
	
	inline mvoid SetColor( MAJAMATHS::MajaQuaternion& c){ 
		color= c;
	}
	
	inline MAJAMATHS::MajaQuaternion& GetColor( mvoid){ 
		return color;
	}
	
	inline mvoid Draw( mvoid)
	{
		glPushMatrix();
		//glBindTexture( GL_TEXTURE_2D, image_id);
	
		glBegin( GL_QUADS);
		glColor4f( color.x, color.y, color.z, color.w);
		//glTexCoord2f( 0,0);
		glVertex3f( pos.x, pos.y, pos.z); 
		//glTexCoord2f( 0,-1);
		glVertex3f( pos.x, pos.y+size.y, pos.z); 
		//glTexCoord2f( 1,-1);
		glVertex3f( pos.x+size.x, pos.y+size.y, pos.z); 
		//glTexCoord2f( -1,0);
		glVertex3f( pos.x+size.x, pos.y, pos.z); 
		glEnd();

		glColor4f( text_color.x, text_color.y, text_color.z, text_color.w);
		glRasterPos3f( pos.x, pos.y+size.y/2, pos.z+.1);
		text_out.Print( label);
			
		glPopMatrix();
	}
};
}
#endif

