/*
	majamenu.h
	ce fichier est une partie de Maja - this is a part of Maja
	simple base pour les menus
	simple basics for menus

	$Id: $

	$Log: $

	begin:			Fri Jul 5 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef __MAJA_MENU_H
#define __MAJA_MENU_H

#include "majalabel.h"
#include "majamenuitem.h"

namespace maja
{
	template
	<
		class D,
		class ITEM,
		template <class> class POLICY
	>
	class MajaMenu:	public MajaLabel, public POLICY<ITEM>
	{
		MAJACONTAINER::MajaList<ITEM>	menu_list;

		MajaLabel			background;

		std::string			file_name;

		mbool				use_bg;
	
		public:
	
		MajaMenu( mvoid): MajaLabel(), POLICY<ITEM>(){
			use_bg= mtrue;
		}
	
		~MajaMenu( mvoid){
			;
		}

		static mvoid Connect( D d, std::string font_name){
			text_out._d= d._d;
			text_out.SetFont( font_name.c_str());
		}

		mvoid AddItem( ITEM& i){
			i.SetPos( i.GetPos().x, size.y-pos.y-i.GetPos().y, .0);
			menu_list.AddObject( &i);
		}

		mvoid Draw( mvoid){
			MAJACONTAINER::MajaWidget<ITEM> *tmp= menu_list.GetFirst();

			glPushMatrix();

			if( use_bg)
				background.Draw();
			while( tmp){
				tmp->GetObject()->Draw();
				tmp= tmp->GetNext();
			}
	
			glPopMatrix();
		}

		mcom Test( mint mx, mint my, mint b){
			MAJACONTAINER::MajaWidget<ITEM> *tmp= menu_list.GetFirst();
			muint s;
			mcom ans= mcom_nothing;

			while( tmp){
				s= tmp->GetObject()->TestMouse( mx, (mint)(size.y-pos.y-my), b);
			
				if( s== MAJA_MENU_ACTIVE)
					return Active( *tmp->GetObject());
				else if( s== MAJA_MENU_FOCUS)
					ans= Focus( *tmp->GetObject());
				else if( s== MAJA_MENU_INACTIVE)
					ans= Inactive( *tmp->GetObject());

				if( ans>=mcom_error)
					return ans;

				tmp= tmp->GetNext();
			}

			return mcom_no_change;
		}

		mbool Load(){
			return mfalse;
		}

		mbool Save(){
			return mfalse;
		}

		mvoid SetFileName( std::string m_file){
			file_name= m_file;
		}

		MajaLabel& GetBackground(){
			return background;
		}

		mvoid SetBackgroundTexture( GLuint i){
			background.SetImage( i);
		}

		mvoid SetUseBackground( mbool v){
			use_bg= v;
		}
	};
}
#endif
