/* modulease.h , this is a part of Maja
 * module that load 3d models
 * Copyright (C) september 2000,2001,2002 by Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
	For all the Ase loading:
	Original copyright:
	Copyright 1999 by Nate 'm|d' Miller
	For non-commercial use only!
	
	File			ase.h
	Date			5/29/99
	Author			Nate 'm|d' Miller
	Contact		vandals1@home.com
	Web			http://members.home.com/vandals1
*/

#ifndef __MAJA_MODULEASE
#define __MAJA_MODULEASE

#include "module.h"

// For Ase
// make sure that we have the structures i love to use defined
#define NUM_VERTEX				"*MESH_NUMVERTEX"
#define NUM_FACES					"*MESH_NUMFACES"
#define NUM_TVERTEX				"*MESH_NUMTVERTEX"
#define NUM_TFACES				"*MESH_NUMTVFACES"
#define VERTEX_LIST				"*MESH_VERTEX_LIST"
#define VERTEX						"*MESH_VERTEX"
#define FACE_LIST					"*MESH_FACE_LIST"
#define FACE						"*MESH_FACE"
#define NORMALS					"*MESH_NORMALS"
#define FACE_NORMAL				"*MESH_FACENORMAL"
#define NVERTEX					"*MESH_VERTEXNORMAL"
#define TVERTEX					"*MESH_TVERT"
#define TFACE						"*MESH_TFACE"
#define TEXTURE					"*BITMAP"
#define UTILE						"*UVW_U_TILING"
#define VTILE						"*UVW_V_TILING"
#define UOFFSET					"*UVW_U_OFFSET"
#define VOFFSET					"*UVW_V_OFFSET"

// For Ase
#ifndef vec_t
typedef float vec_t;
typedef vec_t vec2_t[2];
typedef vec_t vec3_t[3];
#endif

/*
	the Ase model
	i don't know if i have to keep it in maja
	so it isn't finished due to some settings problems
	and for uncertainity
	
	note: this is not in development yet, still it is a sub functionnality
			more things more important !
*/
class MajaAseModule
{
	protected:
	// a triangle in the Ase model
	struct triangle_t
	{
		int vertIndex[3];  				// indicies for the verts that make up this triangle
		int coordIndex[3]; 			// indicies for the tex coords to texture this face
		vec3_t normal;     			// face normal
	};

	// texture information for the Ase model
	struct texture_t
	{
		char texfilename[256];		// texture name
		int texId;         				// texture id
		vec_t uTile;       				// u tiling of texture
		vec_t vTile;       				// v tiling of texture
		vec_t uOffset;     			// u offset of texture
		vec_t vOffset;     			// v offset of texture
	};
	
	public:
	int numVertex;				// number of verts in the model
	int numFaces;				// number of faces in the model
	int numTexFaces;			// number of textured faces in model
	int numTexVertex;			// number of texture coords
	int normals;					// do we have normal information?
	GLfloat *verts;				// model verts
	GLfloat *texVerts;			// texture coords
	GLfloat *vertNorms;			// vertex normals
	triangle_t *faces;				// faces of model
	texture_t texture;				// texture information
	int *vertIndex;					// indicies for the verts that make up this triangle
	FILE *file;
	char filename[256];
	
	MajaAseModule( char *file_name, GLuint& list, char *tex_file="\0");
	~MajaAseModule( void);
	private:
	void aseGetVertex( void);
	void aseGetTVertex( void);
	void aseGetNVertex( void);
	void aseGetFaceNormal( void);
	void aseGetFace( void);
	void aseGetTFace( void);
	void aseGetTextureName( void);
	vec_t aseGetFloatVal( void);
	void aseGetData( void);
	void aseLoadTexture( void);
	void aseDumpInfo( void);	
};
#endif
