/* $Id: $
 * majaplayer.h, this is a part of Maja
 * Class MajaPlayer
 * Copyright (C) september 2000,2001,2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: $
 */

#ifndef __MAJAPLAYER_H
#define __MAJAPLAYER_H

#include "majasimple.h"
#include "../interactivity/mplayer.h"

namespace maja
{
	
/*!
	MajaPlayer is the most simple object for a player (other not available for now)
	give him the modifications applied (speed, angles) and it will move as you
	decided. This must be rename MajaSimplePlayer due to its parent.
*/
class MajaSimplePlayer:	public MajaSimpleMotion, 
			protected MPlayer
{
	protected:

	mint *mx;
	mint *my;
	
	public:
	
	MajaSimplePlayer( mvoid):	MajaSimpleMotion(), 
					MPlayer(){
		mx= mnull;
		my= mnull;
	}
	
	MajaSimplePlayer( const MajaSimplePlayer& p);
	
	virtual ~MajaSimplePlayer(){}

	//!-----------
	//! Tools
	//!-----------
	
	//! define score
	inline mvoid DefineScore( muint s){this->score= s;}
	
	//! obsolet, go forward (at direction vector)
	//! maybe usefull for a plane simulation
	mbool WalkOn ( mfloat t, MajaVector *vect= NULL);
	
	//! turn it
	bool TurnOn ( MajaVector *a= NULL, real dt=0);
	
	void Submit( void *k, void *m);

	void LinkMouse( int *x, int *y){
		mx=x;
		my=y;
	}

	protected:
	
	void SetForwardKey( int key)	{ forward= key;}
	
	void SetBackwardKey( int key)	{ backward= key;}
	
	void SetLeftTurnKey( int key)	{ step_left= key;}
	
	void SetRightTurnKey( int key)	{ step_right= key;}
};
}
#endif
