/* $Id: $
 * winattr.h , this is a part of Maja
 * attributes for your window
 * Copyright (C) september 2000, 2001, 2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: $
 */

/*
	known bugs:
	. under Enlightenment 0.17, when using the right desk,
	switching to fullscreen and then return to window mode,
	we're back to the left desk. Is it a e problem or a x one ?
*/
#ifndef MAJA_WINATTR__H
#define MAJA_WINATTR__H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef WIN32
#include <GL/glx.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
#endif

namespace maja
{
	
class MajaWinAttr
{
	public:
		
	int x, y;
	
	unsigned int width, height;
	
	unsigned int depth;
	
	bool			fullscreen;
	
	char			*name;
	
	#ifndef WIN32
	XSetWindowAttributes attributes;
	#endif
	
	int glx_attr[25];
	int glx_attr_nb;

	MajaWinAttr( void);

	~MajaWinAttr(){
		delete[] name;
	}

	void SetName( char *n);

	void SetPosition( unsigned int x, unsigned int y);

	void SetSize( unsigned int w, unsigned int h);

	void SetDepth( unsigned int d);

	void SetFullScreen( bool f);

#ifndef WIN32
	void SetXWAttr( XSetWindowAttributes& a);
#endif	
};

}
#endif
