/***************************************************************************
                          winevent.h  -  description
                             -------------------
    begin                : Mon Jul 15 2002
    copyright            : (C) 2002 by Jean-Dominique Frattini
    email                : jd.frattini@tuxfamily.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __MAJA_WINEVENT_H
#define __MAJA_WINEVENT_H

#include <GL/glext.h>
#ifndef WIN32
#include <GL/glx.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
#else
#include <windows.h>
#include <GL/wglext.h>
#endif

class MajaWinEvent
{
	#ifndef WIN32
		XEvent	event;
	#else
		int	event;
	#endif
	
	public:
	MajaWinEvent( void){}
	
	XEvent& GetEvent( void){ return event;}
	
	void SetEvent( XEvent e){ event= e;}
	
	//! the only arg should be of _MajaDisplay type cause of windows
	XEvent& GetNextEvent( Display* display){
		XNextEvent( display, &event);
		return event;
	}
};

#endif
