/* $Id: $
 * defines that controls Maja, this is a part of Maja
 * Copyright (C) 2000,2001,2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: $
 */

#ifndef __MAJA_DEF_H
#define __MAJA_DEF_H

#define __MAJA_WARNING						100
#define __MAJA_ERROR							200
#define __MAJA_FATAL_ERROR					300
#define __MAJA_UNKNOWN						400

#define __MAJA_WARNING_TEXT				cerr << endl << "!!! Maja Warning ! "
#define __MAJA_ERROR_TEXT					cerr << endl << "!!! Maja Error ! "
#define __MAJA_FATAL_ERROR_TEXT			cerr << endl << "!!! Maja Fatal Error ! "
#define __MAJA_UNKNOWN_TEXT				cerr << endl << "!!! Maja Unknown Error ! "

#define __MAJA_MLS_POINTER_ERROR		"Can't copy a MajaScene pointer for MajaSceneList instance, possible problem of memory."
#define __MAJA_NO_MS_INSTANCE			"No MajaScene in MajaSceneList instance, couldn't draw."
#define __MAJA_MS_ALLOC_ERROR			"Couldn't allocate a MajaScene type for a MajaSceneList instance."
#define __MAJA_MLP_POINTER_ERROR		"Can't copy a MajaPath pointer for MajaPathList instance, possible problem of memory."
#define __MAJA_NO_MP_INSTANCE			"No MajaPath in MajaPathList instance, couldn't draw."
#define __MAJA_MP_ALLOC_ERROR			"Couldn't allocate a MajaPath type for a MajaPathList instance."
#define __MAJA_NULL_MOD_MOD				"Invalid module variable initialized."

#define MAJA_CPU_FREQUENCY_TEST		1000000000
#define MAJA_FREQUENCY_UNIT				1000
#define MAJA_FREQUENCY_UNIT_TEXT		" MHz"

/*!
	Undef what you don't want
*/

//! Mode plein-cran pour les non voodoo:
//#define MAJA_FULLSCREEN						4

/*! -- Si vous avez une 3DFX 1 ou 2: -- */
//! Utilisation de l'acclration en plein cran:
//#define MAJA_USE_FULLSCREEN_3DFX		5
//! Utilisation d'OpenGL en fentr
//#define MAJA_USE_WINDOW_3DFX			6

// Vidos (pour l'instant l'intro)
//#define MAJA_USE_VIDEOS						7

/* ---- */
//! Utilisation des musiques:
//#define MAJA_USE_MUSIC						8
//#define MAJA_USE_SOUND						9

/*! -- Dtail des graphismes des polygnes -- */
//! Dtail des polygnes bas:
//#define MAJA_USE_WORSTS_DRAWS			10
//! Dtail moyen des polygnes:
//#define MAJA_USE_MEDIUM_DRAWS			11
//! Dtail haut des polygnes:
#define MAJA_USE_NICEST_DRAWS				12
/* ---- */

//! Utilisation des textures:
#define MAJA_USE_TEXTURE						13
//! Utilisation du lissage des couleurs, ombres:
#define MAJA_USE_SMOOTH_SHADE			14

//! Utilisation de la lumire:
#define MAJA_USE_LIGHT							15
//! Utilisation du blendig, de la transparence, de l'anti-aliasing
#define MAJA_USE_BLEND							16

#endif
