/*
	basetransform.h
	ce fichier est une partie de Maja - this is a part of Maja
	bases des transformations gometriques
	basis of the geometric transformations
	
	$Id: $

	$Log: $

	begin:			Fri Aug 16 2002
	copyright:		(C) 2000, 2001, 2002 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	Contactez-nous pour toute tentative d'utilisation commerciale, svp.			*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *	Contact us for any commercial use attempt, please.					*
 *												*
 ************************************************************************************************/

#ifndef __BASE_TRANSFORM_H
#define __BASE_TRANSFORM_H

#include <math.h>
#include <string.h>
#include <iostream>
#include "majascalar.h"
#include "majavector.h"
#include "majamatrix.h"

namespace maja
{
namespace MAJAMATHS{

class MajaBaseTransform
{
	protected:
	
	MajaVector		*vector;
	MajaMatrix		matrix;
	MajaVector		center;
	MajaVector		*source;
	
	MajaBaseTransform( void)
	{
		;
	}
	
	virtual ~MajaBaseTransform( void)
	{
		;
	}
	
//	virtual inline bool Transform( void)=0; //?
	
	inline void SetVector( MajaVector& v){ vector= v;}
	
	inline MajaVector& GetVector( void){ return vector;}
	
	inline void SetMatrix( MajaMatrix& m){ matrix= m;}
	
	inline MajaMatrix& GetMatrix( void){ return matrix;}
};

class MajaTranslation: public MajaBaseTransform
{
	protected:
	
	MajaVector&		translate_vector;
	
	public:
	
	MajaTranslation( void):	MajaBaseTransform(),
				vector( new MajaVector()),
				translate_vector( *vector)
	{
		;
	}
	
	MajaTranslation( MajaVector& centre, MajaVector& v)
	{
		;
	}
	
	bool Translate( void);
};

}//namespace MAJAMATHS

}
#endif
