/*
	majascalar.h
	ce fichier est une partie de Maja - this is a part of Maja
	classe de base pour les composants mathmatiques
	basis class for mathematics components
	
	$Id: $

	$Log: $

	begin:			Sun Aug 11 2002 (new from old maths)
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#ifndef MAJA_SCALAR_H
#define MAJA_SCALAR_H

#include <math.h>
#include <string>
#include <iostream>
#include "../../common/majatypes.h"

namespace maja
{
	
namespace MAJAMATHS
{

typedef mdouble	_scalar;

/*!
	virtual base class for all the math hierarchy
	never use this type yourself.
	
	status:	* has changed quite from the diagram
			* is quite Ok for inheritance
*/
class MajaScalar
{
	protected:
	
	//! a pointer to an array
	_scalar		*scalar_ptr;
	
	//! number of entities in the array
	muint		entity_nb;

	MajaScalar( muint i=0)
	{
		if( i)
			Allocate( i);
	}
	
	virtual ~MajaScalar( mvoid)
	{
		;
	}
	
	//! allocate the array in relation with the entity_nb
	inline mvoid Allocate( muint nb)
	{
		scalar_ptr= mnull;
		scalar_ptr= new _scalar[entity_nb=nb];
		if( !scalar_ptr){
			std::cerr << std::endl << "memory full";
			throw std::exception();
		}

		muint i= 0;
		for( ;i<entity_nb;i++)
			scalar_ptr[i]= 0;
	}
	
	//! free the array when finish using the Maja math component
	inline mvoid Free( mvoid)
	{
		delete[] scalar_ptr;
		scalar_ptr= mnull;
	}

	public:

	//! get a pointer to the first element of the vector inner array
	inline _scalar* GetPointer( mvoid)
	{ 
		return &scalar_ptr[0];
	}
};

}//namespace MAJAMATHS
}
#endif
