/*
	majasmodule.cpp
	ce fichier est une partie de Maja - this is a part of Maja
	modules d'ordonnanceur
	scheduler modules

	$Id: $

	$Log: $

	begin:			Fri Jul 5 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#include "core/majasmodule.h"

namespace maja
{
	
namespace MAJACORE
{
	mbool MajaSModule::first_module= mtrue;
	
	MajaSModule::MajaSModule( muint mutex_nb): MAJATHREAD::MajaThread(), MAJATHREAD::MajaMutex( mutex_nb)
	{
		state= MMS_state_off;
		type= MST_type_maja;
		sub_module= mnull;
		max_sec_busy= __MAJA_DEFAULT_MAX_SEC_BUSY;
		max_inner_loop= __MAJA_MAX_MODULE_INNER_LOOP;
		maja_internal_name= mnull;
		if( first_module){
			GetPriority();
			first_module= mfalse;
		}
	}

	MajaSModule::~MajaSModule( mvoid)
	{
		delete[] maja_internal_name;
	}

	mvoid MajaSModule::SetName( mchar* name)
	{	
		if( !name){
			maja_internal_name= new mchar[strlen( typeid( this).name())+1];
			if( !maja_internal_name) 
				return;
			strcpy( maja_internal_name, typeid( this).name());
		}
		else{
			maja_internal_name= new mchar[strlen( name)+1];
			if( !maja_internal_name) 
				return;
			strcpy( maja_internal_name, name);
		}
	}

	mbool MajaSModule::SetSubModule( MajaSModule *sm)
	{
		if( !sm)
			return mfalse;
		
		sub_module= sm;
		
		return mtrue;
	}

/*	mint MajaSModule::EnterDefaultMode( mvoid *params)
	{
		sched_param sp;

		pthread_attr_init( &attributes);
		pthread_attr_setschedpolicy( &attributes, maja_schedule_algo);
		pthread_attr_getschedparam( &attributes, &sp);		
		sp.sched_priority= priority;
		pthread_attr_setschedparam( &attributes, &sp);
		std::cerr << std::endl << maja_internal_name << ": priority= " << priority;

		if( !Create( mnull)){
			std::cerr << std::endl << "could not create module thread";
			if( errno==EPERM)
				std::cerr << std::endl << "you may not be seteuid=0";
			return 0;
		}

		return 1;
	}*/
}
}
