/* majasound.h , this is a part of Maja
 * sound for Maja
 * Copyright (C) september 2000-2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "engines/audio/majasound.h"

void poked( int sig)
{
	done = 1;
}
#ifndef WIN32
//Prototype of our callback function
void fillerup( void *unused, Uint8 *stream, int len)
{

	Uint8 *waveptr;
	int    waveleft;


	waveptr = wave.sound + wave.soundpos;
	waveleft = wave.soundlen - wave.soundpos;

	while ( waveleft <= len){
		SDL_MixAudio( stream, waveptr, waveleft, SDL_MIX_MAXVOLUME);
		stream+= waveleft;
		len-= waveleft;
		waveptr = wave.sound;
		waveleft = wave.soundlen;
		wave.soundpos = 0;
	}
	SDL_MixAudio( stream, waveptr, len, SDL_MIX_MAXVOLUME);
	wave.soundpos+= len;
};

void init_sound( void)
{
	// init du son par SDL: quasi copier/coller

	if ( SDL_Init( SDL_INIT_AUDIO)< 0){
		fprintf( stderr, "Couldn't initialize SDL: %s\n", SDL_GetError());
		exit( 1);
	}
	atexit( SDL_Quit);

	if ( SDL_LoadWAV( "audio/new noise.wav", &wave.spec, &wave.sound, &wave.soundlen)== NULL){
		fprintf( stderr, "Couldn't load %s: %s\n", "new noise", SDL_GetError());
		exit( 1);
	}
	wave.spec.callback= fillerup;
	
	#ifdef SIGHUP
		signal( SIGHUP, poked);
	#endif
		signal( SIGINT, poked);
	#ifdef SIGQUIT
		signal( SIGQUIT, poked);
	#endif
	signal( SIGTERM, poked);
	
	cerr << ".";

	if ( SDL_OpenAudio( &wave.spec, NULL)< 0) {
		fprintf( stderr, "Couldn't open audio: %s\n", SDL_GetError());
		SDL_FreeWAV( wave.sound);
		exit( 2);
	}

//	while (! done && (SDL_GetAudioStatus() == SDL_AUDIO_PLAYING))
//		SDL_Delay(1000);
}
#endif
