/*
	majagtext.h
	ce fichier est une partie de Maja - this is a part of Maja
	gestion des textures vu pour le moteur graphique
	textures management seen for the graphic engine

	$Id: $

	$Log: $

	begin:			Jun 2002
	copyright:		(C) 2002 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	Contactez-nous pour toute tentative d'utilisation commerciale, svp.			*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *	Contact us for any commercial use attempt, please.					*
 *												*
 ************************************************************************************************/

#include "engines/graphic/majagtext.h"

namespace maja
{
namespace MAJAGRAPHIC{

MajaGTexture::MajaGTexture( void): MajaGEntity()
{
	textures= NULL;
	textures2= NULL;
	tex_rot= NULL;
	nb= 0;
}

MajaGTexture::~MajaGTexture( void)
{
	free( textures);
	free( textures2);
	free( tex_rot);
}

GLuint MajaGTexture::SetNewTexture( GLuint tex, GLfloat rot, GLuint tex2, GLfloat rot2)
{
	GLuint *temp= (GLuint*)realloc( textures, (nb+1)*sizeof( GLuint));
	GLfloat *t_rot= (GLfloat*)realloc( tex_rot, (nb+1)*sizeof( GLfloat));
	GLuint *t2= (GLuint*)realloc( textures2, (nb+1)*sizeof( GLuint));
	
	if( !temp || !t_rot || !t2)
		return false;
		
	textures= temp;
	tex_rot= t_rot;
	textures2= t2;

	textures[nb]= tex;
	textures2[nb]= tex2;
	tex_rot[nb]= rot2;
	nb++;
	
	return nb;
}

bool MajaGTexture::RemoveTexture( GLuint n)
{
	if( n>nb || n<0)
		return false;
	
	if( n<nb){
		for( GLuint i=n; i<nb-1; i++){
			textures[i]= textures[i+1];
			textures2[i]= textures2[i+1];
			tex_rot[i]= tex_rot[i+1];
		}
	}
	
	GLuint *temp= (GLuint*)realloc( textures, (nb)*sizeof( GLuint));
	GLuint *t2= (GLuint*)realloc( textures2, (nb)*sizeof( GLfloat));
	GLfloat *t_rot= (GLfloat*)realloc( tex_rot, (nb)*sizeof( GLfloat));
	
	if( !temp || !t_rot || !t2)
		return false;
		
	textures= temp;
	textures2= t2;
	tex_rot= t_rot;
	
	return true;
}

GLuint MajaGTexture::GetTextureIndex( GLuint tex_id)
{
	if( tex_id>nb)
		return 0;
		
	for( GLuint i=0; i<nb; i++)
		if( textures[i]==tex_id)
			return i;
	
	return 0;
}

GLfloat	MajaGTexture::AreResidentTextures( void)
{
/*	GLfloat moyene=0, total= 0;
	GLint *vals= new GLfloat[nb];
	GLuint i=0;
	
	if( !vals){
		cerr << endl << "memory full";
		return -1;
	}
	
	if( g_technic<= MGT_array)
		glAreTexturesResident( nb, textures, (GLboolean*)vals);
	else
		gl_ext->AreTexturesResident( nb, textures, (GLboolean*)vals);
	
	for( i=0; i< nb, i++)
		total+= (GLfloat)vals[i];
		
	moyene= total/nb;
			
	return moyene;*/return 0.5;
}

}

}
