/* $Id:$
 * textures for Maja
 * Copyright (C) september 2000-2002 Jean-Dominique Frattini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Cette license est valable en terme de droit franais. Cela signifie que c'est la
 * lgislation franaise qui est en vigueur pour l'ensemble des sources contenues
 * dans la librairie. Sauf image.cpp et image.h, se reposant sur aucune license explicite,
 * mais qui sont fournies aimablement dans les librairies Mesa sous license LGPL.
 *
 * Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
 * le modifier sous les termes de la license publique gnrale
 * publie par la Free Software Foundation; soit la version 2 de la
 * license, ou (si vous le voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir d'tre utile, mais
 * SANS AUCUNE GARANTIE; et mme une garantie implicite,
 * y compris les garanties de COMMERCIALISATION ou D'ADAPTATION
 * DANS UN BUT SPCIFIQUE. Prenez connaissance de la License Publique
 * Gnrale GNU pour plus de dtail.
 *
 * Vous devez avoir reu une copie de la License Publique Gnrale
 * GNU avec ce programme; si ce n'est pas le cas, vrivez  la
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log:$
 */

#include "engines/graphic/majatextures.h"
#include <iostream>

namespace maja
{
MAJACONTAINER::MajaList<MajaTex> MajaTextures::textures;
bool MajaTextures::first= true;
GLuint MajaTextures::maja_tex_id= 0;

MajaTextures::MajaTextures( void)
{
	directory= NULL;
//	SetGlobalDir( MAJA_TEXTURE_DIRECTORY);
//	if( first){
	//	maja_tex_id= Create( "images/maja.tga");
//		first= false;
//	}
}

bool MajaTextures::LoadAll( void)
{
	MAJACONTAINER::MajaWidget<MajaTex> *tmp= NULL;
	
	tmp= textures.GetFirst();
	if( !tmp) 
		return false;
	
	MajaTex *tmp_tex= NULL;
	while( tmp){
		tmp_tex= tmp->GetWidget();
		tmp_tex->LoadImage();
		tmp= tmp->GetNext();
	}

	return true;
}

GLuint MajaTextures::Create( char *texture_file_name, char *directory_name)
{
	MAJACONTAINER::MajaWidget<MajaTex> *tmp= NULL;
	tmp= textures.GetFirst();
	
	MajaTex *tmp_tex= NULL;
	char *tmp_name= NULL;
	
	if( directory_name){
		if( directory) 
			delete[] directory;
		
		directory= new char[strlen( directory_name)+1];					// new
		if( !directory) 
			return 0;
		strcpy( directory, directory_name);
		
		tmp_name= new char[ strlen( texture_file_name)+1+strlen( directory_name)];	// new
		if( !tmp_name) 
			return 0;
		strcpy( tmp_name, directory);
		strcat( tmp_name, texture_file_name);
	}
	else if( directory){
		tmp_name= new char[ strlen( texture_file_name)+1+strlen( directory)];		// new
		if( !tmp_name) 
			return 0;
		strcpy( tmp_name, directory);
		strcat( tmp_name, texture_file_name);
	}
	else{
		tmp_name= new char[ strlen( texture_file_name)+1];				// new
		if( !tmp_name) 
			return 0;
		strcpy( tmp_name, texture_file_name);
	}
	
// TODO: implement jpg, tga loading, so that this disappears
	if( strstr( tmp_name, ".JPG")){
		int pos=0;
		char *tmp_is;
		char *tmp_c= NULL;
		tmp_is= strrchr( tmp_name, '.');
		pos= tmp_is-tmp_name;
		
		tmp_c= new char[pos+5];
		
		strncpy( tmp_c, tmp_name, pos);
		tmp_c[pos]='\0';
		strcat( tmp_c, ".rgb");
		strcpy( tmp_name, tmp_c);
		
		delete tmp_c;
	}
	
	if( !tmp){
		tmp_tex= new MajaTex();
		if( !tmp_tex) 
			return 0;
		
		tmp_tex->Init( tmp_name);
		textures.AddObject( tmp_tex);

		delete[] tmp_name;
		
		return tmp_tex->GetId();
	}
	else{
		tmp_tex= textures.Seek( tmp_name);
		if( !tmp_tex){
			MajaTex *tmp_new= new MajaTex();
			if( !tmp_new) return 0;
			tmp_new->Init( tmp_name);
			textures.AddObject( tmp_new);
			GLuint id= tmp_new->GetId();

			delete[] tmp_name;
			
			return id;
		}
		else{
			delete[] tmp_name;

			return tmp_tex->GetId();
		}
	}

	return 0;
}

void MajaTextures::SetDirectory( char* dir)
{
	if( directory && strlen( directory)< strlen( dir)) 
		delete directory;
	
	directory= new char[strlen( dir)+1];
	if( !directory) 
		return;
	
	strcpy( directory, dir);
}

}// namespace maja
