/*
	majamouse.cpp
	ce fichier est une partie de Maja - this is a part of Maja
	support de la souris
	mouse support

	$Id: $

	$Log: $

	begin:			Mon Jul 15 2002
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#include "engines/interactivity/majamouse.h"
#include "engines/interactivity/keymatch.h"

namespace maja
{

// simple bad way internal routine
#ifndef WIN32
Cursor CreateXCursor( Display *display, _MajaWindow *window, Cursor cursor)
{
	Pixmap		mask;
	XGCValues	xgc_val;
	GC		gc;
	XColor		color;
	
	mask= XCreatePixmap( display, *window, 1,1,1);
	xgc_val.function= GXclear;
	gc= XCreateGC( display, mask, GCFunction, &xgc_val);
	XFillRectangle( display, mask, gc, 0,0,1,1);
	color.pixel=0;
	color.red=0;
	color.flags=4;
	cursor= XCreatePixmapCursor( display, mask, mask, &color, &color, 0,0);
	XFreePixmap( display, mask);
	XFreeGC( display, gc);

	return cursor;
}
#endif

void MajaMouse::Create( void)
{
	XDefineCursor( display, *window, CreateXCursor( display, window, cursor));
}

void MajaMouse::Grab( void)
{
	XGrabPointer( display, *window, false, 0, GrabModeAsync, GrabModeAsync, None, cursor, CurrentTime);
}

void MajaMouse::SetInputFocus( void)
{
	XSetInputFocus( display, *window, RevertToNone, CurrentTime);
}

__MajaWindowState MajaMouse::CheckEvent( _MajaWinEvent& e)
{
	pos.x= e.xmotion.x;
	pos.y= e.xmotion.y;

	switch( e.type){

		case ButtonPress:

			switch( e.xbutton.button){

				case 1:
					current_k_mouse= MAJA_MOUSE_1;
					break;
				case 2:
					current_k_mouse= MAJA_MOUSE_2;
					break;
				case 3:
					current_k_mouse= MAJA_MOUSE_3;
					break;
				case 4:
					current_k_mouse= MAJA_MOUSE_4;
					break;
				case 5:
					current_k_mouse= MAJA_MOUSE_5;
					break;
				default:
					current_k_mouse= 0;
			}

			break;

		case ButtonRelease:
			current_k_mouse= 0;
			break;
			
		default:
			current_k_mouse= 0;
	}

	// that's a bit a shame !
	return MWS_state_alive;
}
}
