/*
	majathread.cpp
	ce fichier est une partie de Maja - this is a part of Maja
	gestion des threads
	threads management

	$Id: $

	$Log: $

	begin:			Mon Jul 8 2002 (from majascheduler.h)
	copyright:		(C) 2000,2001,2002,2003 by Jean-Dominique Frattini
	email:			jd.frattini@tuxfamily.org	
*/

/************************************************************************************************
 *												*
 *	Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou le modifier	*
 *	sous les termes de la GNU General Public License comme publie par			*
 *	la Free Software Foundation; soit en utilisant la verstion 2 de cette license, ou	*
 *	(si vous le voulez) toute version ultrieure.						*
 *	-											*
 *	This program is free software; you can redistribute it and/or modify			*
 *	it under the terms of the GNU General Public License as published by			*
 *	the Free Software Foundation; either version 2 of the License, or			*
 *	(at your option) any later version.							*
 *												*
 ************************************************************************************************/

#include "layers/th/majathread.h"

namespace maja
{
	namespace MAJATHREAD
	{
		muint MajaThread::count=0;

		static mvoid* __maja_thread_func( mvoid* th)
		{
			MajaThread* tmp= (MajaThread*)th;
			if( !th){
				std::cerr << std::endl << "__maja_thread_func(): ERROR ! pointer must not be null !";
				exit( 1);
			}
	
			tmp->Go( tmp->GetParam());
		
			return mnull;
		}

		MajaThread::MajaThread( mvoid)
		{
			priority_min= priority_max= priority= 0;
			maja_schedule_algo= SCHED_OTHER;
			count++;
		}

		MajaThread::~MajaThread( mvoid)
		{
			if( pthread_equal( pthread_self(), thread)){
				pthread_cancel( thread);
				pthread_exit( mnull);
				pthread_attr_destroy( &attributes);
			}
			count--;
		}

		mint MajaThread::Create( mvoid* thread_param)
		{
			mint ret;

			ret= pthread_create( &thread, &attributes, __maja_thread_func, this);

			if( ret==0)
				return 1;
			else{
				std::cerr << std::endl << "MajaThread: Error while creating pthread with " << std::strerror( ret);
				return 0;
			}
		}
	}
}
